const Cc = Components.classes;
const Ci = Components.interfaces;
const Cu = Components.utils;
const Cm = Components.manager;
const Cr = Components.results;

Cu.import("resource://gre/modules/Services.jsm");
Cu.import("resource://gre/modules/XPCOMUtils.jsm");

prefs = Cc["@mozilla.org/preferences-service;1"].getService(Ci.nsIPrefService).getBranch("extensions.glassmyfox-extension.");
prefs2 = Cc["@mozilla.org/preferences-service;1"].getService(Ci.nsIPrefService).getDefaultBranch("extensions.glassmyfox-extension.");
prefs3 = Cc["@mozilla.org/preferences-service;1"].getService(Ci.nsIPrefService).getDefaultBranch("services.sync.prefs.sync.extensions.glassmyfox-extension.");

function install(params, reason) {}

function uninstall(params, reason) {

	// double check to not delete branch, if add-on
	// is just being upgraded. Remove branch on the 'real'
	// uninstall only.
	if(ADDON_UPGRADE==reason){return;}
		else if (ADDON_UNINSTALL!=reason) {return;}
			else {this.prefs.deleteBranch("");this.prefs3.deleteBranch("");}
}

function startup(params, reason){

	  // select correct tabs option automatically on first start (Fx 24-28 or Fx 29+)
	  if (parseInt(Cc["@mozilla.org/preferences-service;1"].getService(Ci.nsIPrefService).getBranch("extensions.").getCharPref("lastAppVersion")) >= 29) {
		
		this.prefs2.setCharPref("gmftabset","taust3");
		
	  } else {
	  
	    this.prefs2.setCharPref("gmftabset","tglass6i");
		
	  }

	this.prefs2.setBoolPref("overlay",true);
	this.prefs2.setBoolPref("mainwindowglass",true);
	this.prefs2.setIntPref("libraryglass",1);
	this.prefs2.setIntPref("preferencesglass",1);
	this.prefs2.setIntPref("sidebarglass",1);
	this.prefs2.setIntPref("appbutton",1);
	this.prefs2.setBoolPref("appbuttonicon",false);
	this.prefs2.setBoolPref("dlwindowglass",true);
	this.prefs2.setIntPref("dropdownbg",0);
	this.prefs2.setIntPref("dropdowntc",0);
	this.prefs2.setCharPref("dropdowntcc","#FFFFFF");
	this.prefs2.setCharPref("dropdowntccshadow","#000000");
	this.prefs2.setIntPref("textboxtc",0);
	this.prefs2.setCharPref("textboxtcc","#FFFFFF");
	this.prefs2.setCharPref("textboxtccshadow","#000000");
	this.prefs2.setIntPref("toolbartc",1);
	this.prefs2.setCharPref("toolbartcc","#FFFFFF");
	this.prefs2.setCharPref("toolbartccshadow","#000000");
	this.prefs2.setIntPref("sidebartc",0);
	this.prefs2.setCharPref("sidebartcc","#000000");
	this.prefs2.setBoolPref("tabswt",true);
	this.prefs2.setBoolPref("prefswt",false);
	this.prefs2.setBoolPref("buttonglass",false);
	this.prefs2.setBoolPref("navbarbuttonglass",false);
	this.prefs2.setBoolPref("tooltipglass",true);
	this.prefs2.setIntPref("urlsearchbarglass",0);
	this.prefs2.setBoolPref("toolbartopbgst",false);
	this.prefs2.setBoolPref("toolbarbottombgst",false);
	this.prefs2.setBoolPref("hightabs",false);
	this.prefs2.setBoolPref("tabclose",false);
	this.prefs2.setBoolPref("whitetbbut",false);
	this.prefs2.setBoolPref("highbookm",false);
	this.prefs2.setBoolPref("mseperator",false);
	this.prefs2.setBoolPref("menubarmorespace",false);
	this.prefs2.setBoolPref("noappcontentgradient",false);
	this.prefs2.setBoolPref("ff13newtabglass",false);
	this.prefs2.setBoolPref("abouttabglass",false);
	this.prefs2.setBoolPref("contentglass",false);
	this.prefs2.setBoolPref("expfindbar25",false);
	
	// preferences for Sync
	this.prefs3.setBoolPref("overlay",true);
	this.prefs3.setBoolPref("mainwindowglass",true);
	this.prefs3.setBoolPref("gmftabset",true);
	this.prefs3.setBoolPref("libraryglass",true);
	this.prefs3.setBoolPref("preferencesglass",true);
	this.prefs3.setBoolPref("sidebarglass",true);
	this.prefs3.setBoolPref("appbutton",true);
	this.prefs3.setBoolPref("appbuttonicon",true);
	this.prefs3.setBoolPref("dlwindowglass",true);
	this.prefs3.setBoolPref("dropdownbg",true);
	this.prefs3.setBoolPref("dropdowntc",true);
	this.prefs3.setBoolPref("dropdowntcc",true);
	this.prefs3.setBoolPref("dropdowntccshadow",true);
	this.prefs3.setBoolPref("textboxtc",true);
	this.prefs3.setBoolPref("textboxtcc",true);
	this.prefs3.setBoolPref("textboxtccshadow",true);
	this.prefs3.setBoolPref("toolbartc",true);
	this.prefs3.setBoolPref("toolbartcc",true);
	this.prefs3.setBoolPref("toolbartccshadow",true);
	this.prefs3.setBoolPref("sidebartc",true);
	this.prefs3.setBoolPref("sidebartcc",true);
	this.prefs3.setBoolPref("tabswt",true);
	this.prefs3.setBoolPref("prefswt",true);
	this.prefs3.setBoolPref("buttonglass",true);
	this.prefs3.setBoolPref("navbarbuttonglass",true);
	this.prefs3.setBoolPref("tooltipglass",true);
	this.prefs3.setBoolPref("urlsearchbarglass",true);
	this.prefs3.setBoolPref("toolbartopbgst",true);
	this.prefs3.setBoolPref("toolbarbottombgst",true);
	this.prefs3.setBoolPref("hightabs",true);
	this.prefs3.setBoolPref("tabclose",true);
	this.prefs3.setBoolPref("whitetbbut",true);
	this.prefs3.setBoolPref("highbookm",true);
	this.prefs3.setBoolPref("mseperator",true);
	this.prefs3.setBoolPref("menubarmorespace",true);
	this.prefs3.setBoolPref("noappcontentgradient",true);
	this.prefs3.setBoolPref("ff13newtabglass",true);
	this.prefs3.setBoolPref("abouttabglass",true);
	this.prefs3.setBoolPref("contentglass",true);
	this.prefs3.setBoolPref("expfindbar25",true);
		
	PrefsObserver.init();
}

function shutdown(params, reason){

	PrefsObserver.shutdown();
}

var PrefsObserver = {
	branch: "extensions.glassmyfox-extension.",

	init: function() {
		for (let gmfoption in gmfsettings)
			this.updateOption(gmfoption);

		Services.prefs.addObserver(this.branch, this, true);
	},

	shutdown: function() {
		for (let gmfoption in gmfsettings)
			gmfsettings[gmfoption].shutdown();

		Services.prefs.removeObserver(this.branch, this);
	},

	updateOption: function(gmfoption) {
		if (!(gmfoption in gmfsettings))
			return;

		try	{
			let enabled;
			if (gmfoption == "overlay" || gmfoption == "gmftabset" || gmfoption == "toolbartcc" || gmfoption == "toolbartccshadow" || gmfoption == "dropdowntcc" || gmfoption == "dropdowntccshadow" || gmfoption == "textboxtcc" || gmfoption == "textboxtccshadow" || gmfoption == "sidebartcc")
				enabled = true;
			else if (Services.prefs.getPrefType(this.branch + gmfoption) == Ci.nsIPrefBranch.PREF_INT)
				enabled = Services.prefs.getIntPref(this.branch + gmfoption) > -1;
			else
				enabled = Services.prefs.getBoolPref(this.branch + gmfoption);
			if (enabled)
				gmfsettings[gmfoption].init();
			else
				gmfsettings[gmfoption].shutdown();
		}
		catch (e) {}
	},

	observe: function(subject, topic, data) {
		if (topic != "nsPref:changed" || data.indexOf(this.branch) != 0)
			return;

		this.updateOption(data.substr(this.branch.length));
	},

	QueryInterface: XPCOMUtils.generateQI([Ci.nsISupportsWeakReference, Ci.nsIObserver])
};

var StylesheetManager = {
	uri: null,
	stylesheetService: Cc["@mozilla.org/content/style-sheet-service;1"].getService(Ci.nsIStyleSheetService),

	init: function() {
		let stylesheet = this.stylesheet;
		if (this.uri && this.uri.spec == stylesheet) return;

		this.shutdown();

		this.uri = Services.io.newURI(stylesheet, null, null);
		this.stylesheetService.loadAndRegisterSheet(this.uri, Ci.nsIStyleSheetService.USER_SHEET);
	},

	shutdown: function() {
		if (!this.uri) return;

		this.stylesheetService.unregisterSheet(this.uri, Ci.nsIStyleSheetService.USER_SHEET);
		this.uri = null;
	}
};

var GMFOverlay = {
	__proto__: StylesheetManager,
	stylesheet: "chrome://glassmyfox-extension/content/overlay.css"
};

var MainWindowGlassSetting = {

	__proto__: StylesheetManager,
	stylesheet: "chrome://glassmyfox-extension/content/css/glassmyfox.css"
};

var GmfTabSettings = {
	
	__proto__: StylesheetManager,
	get stylesheet() {
		let menuvalue = Services.prefs.getCharPref(PrefsObserver.branch + "gmftabset");

		if (menuvalue=="tcustom")	return "chrome://glassmyfox-extension/content/css/tabs_custom.css";
		if (menuvalue=="tglass1")	return "chrome://glassmyfox-extension/content/css/tabs_glasstabsv1.css";
		if (menuvalue=="tglass2")	return "chrome://glassmyfox-extension/content/css/tabs_glasstabsv2.css";
		if (menuvalue=="tglass2i")	return "chrome://glassmyfox-extension/content/css/tabs_glasstabsv2i.css";
		if (menuvalue=="tglass3")	return "chrome://glassmyfox-extension/content/css/tabs_glasstabsv3.css";
		if (menuvalue=="tglass3i")	return "chrome://glassmyfox-extension/content/css/tabs_glasstabsv3i.css";
		if (menuvalue=="tglass4")	return "chrome://glassmyfox-extension/content/css/tabs_glasstabsv4.css";
		if (menuvalue=="tglass5")	return "chrome://glassmyfox-extension/content/css/tabs_glasstabsv5.css";
		if (menuvalue=="tglass6")	return "chrome://glassmyfox-extension/content/css/tabs_glasstabsv6.css";
		if (menuvalue=="tglass6i")	return "chrome://glassmyfox-extension/content/css/tabs_glasstabsv6i.css";
		if (menuvalue=="tgmf1")		return "chrome://glassmyfox-extension/content/css/tabs_gmftabsv1.css";
		if (menuvalue=="tgmf2")		return "chrome://glassmyfox-extension/content/css/tabs_gmftabsv2.css";
		if (menuvalue=="tgmf3")		return "chrome://glassmyfox-extension/content/css/tabs_gmftabsv3.css";
		if (menuvalue=="tgmf4")		return "chrome://glassmyfox-extension/content/css/tabs_gmftabsv4.css";
		if (menuvalue=="taust1")	return "chrome://glassmyfox-extension/content/css/tabs_austr1.css";
		if (menuvalue=="taust2")	return "chrome://glassmyfox-extension/content/css/tabs_austr2.css";
		if (menuvalue=="taust3")	return "chrome://glassmyfox-extension/content/css/tabs_austr3.css";
		if (menuvalue=="taust4")	return "chrome://glassmyfox-extension/content/css/tabs_austr4.css";
	}
};

var LibraryGlass = {

	__proto__: StylesheetManager,
	get stylesheet() {
		let menuvalue = Services.prefs.getIntPref(PrefsObserver.branch + "libraryglass");
		if (menuvalue==1) return "chrome://glassmyfox-extension/content/css/libraryglass1.css";
		if (menuvalue==2) return "chrome://glassmyfox-extension/content/css/libraryglass2.css";
	}
};

var PreferenceGlass = {

	__proto__: StylesheetManager,
	get stylesheet() {
		let menuvalue = Services.prefs.getIntPref(PrefsObserver.branch + "preferencesglass");
		if (menuvalue==1) return "chrome://glassmyfox-extension/content/css/preferencesglass1.css";
		if (menuvalue==2) return "chrome://glassmyfox-extension/content/css/preferencesglass2.css";
	}
};

var SidebarGlass = {

	__proto__: StylesheetManager,
	get stylesheet() {
		let menuvalue = Services.prefs.getIntPref(PrefsObserver.branch + "sidebarglass");
		if (menuvalue==1) return "chrome://glassmyfox-extension/content/css/sidebarglass1.css";
		if (menuvalue==2) return "chrome://glassmyfox-extension/content/css/sidebarglass2.css";
	}
};

var Downloadwindowglass = {

	__proto__: StylesheetManager,
	stylesheet: "chrome://glassmyfox-extension/content/css/downloadwindowglass.css"
};

var ApplicationButton = {

	__proto__: StylesheetManager,
	get stylesheet() {
		let menuvalue = Services.prefs.getIntPref(PrefsObserver.branch + "appbutton");
		if (menuvalue==1) return "chrome://glassmyfox-extension/content/css/appbutglass.css";
		if (menuvalue==2) return "chrome://glassmyfox-extension/content/css/appbutaurora.css";
		if (menuvalue==3) return "chrome://glassmyfox-extension/content/css/appbutnightly.css";
		if (menuvalue==4) return "chrome://glassmyfox-extension/content/css/appbutnobo.css";
		if (menuvalue==5) return "chrome://glassmyfox-extension/content/css/appbutnobo2.css";
	}
};

var ApplicationButtonIcon = {

	__proto__: StylesheetManager,
	stylesheet: "chrome://glassmyfox-extension/content/css/appbuticon.css"
};

var DropDownBg = {

	__proto__: StylesheetManager,
	get stylesheet() {
		let menuvalue = Services.prefs.getIntPref(PrefsObserver.branch + "dropdownbg");
		if (menuvalue==1) return "chrome://glassmyfox-extension/content/css/ddglass.css";
		if (menuvalue==2) return "chrome://glassmyfox-extension/content/css/ddsemitp.css";
	}
};

var DropDownTc = {

	__proto__: StylesheetManager,
	get stylesheet(){
		let menuvalue = Services.prefs.getIntPref(PrefsObserver.branch + "dropdowntc");

		if (menuvalue==5){
		
			gmfsettings["dropdowntcc"].init();
			gmfsettings["dropdowntccshadow"].init();
			return "data:text/css;charset=utf-8," + encodeURIComponent('');
		}			
		
		else{
			gmfsettings["dropdowntcc"].shutdown();
			gmfsettings["dropdowntccshadow"].shutdown();
			
			if (menuvalue==1) return "chrome://glassmyfox-extension/content/css/ddtc1.css";
			if (menuvalue==2) return "chrome://glassmyfox-extension/content/css/ddtc2.css";
			if (menuvalue==3) return "chrome://glassmyfox-extension/content/css/ddtc3.css";
			if (menuvalue==4) return "chrome://glassmyfox-extension/content/css/ddtc4.css";
		}
	}
};

var DropDownTCColor = {
	
	__proto__: StylesheetManager,
	get stylesheet(){
			try{
				let tcustomcolor = Services.prefs.getCharPref(PrefsObserver.branch + "dropdowntcc");
				
				if(prefs.getIntPref("dropdowntc")==5){
					return "data:text/css;charset=utf-8," + encodeURIComponent('\
						@media all and (-moz-windows-compositor){\
							menu, menuitem, .splitmenu-menuitem,\
							.menu-accel, .menu-iconic-accel {\
								color: '+tcustomcolor+' !important;}\
							\
							menu[disabled="true"],menuitem[disabled="true"],\
							.splitmenu-menuitem[disabled="true"],\
							menu[_moz-menuactive="true"][disabled="true"],\
							menuitem[_moz-menuactive="true"][disabled="true"],\
							.splitmenu-menuitem[_moz-menuactive="true"][disabled="true"] {\
								color: '+tcustomcolor+' !important;\
								opacity: .65 !important;}\
						}\
					');
				}
				else return "data:text/css;charset=utf-8," + encodeURIComponent('');
			}catch(e) {Cu.reportError(e)}
		}
};

var DropDownTCShadow = {
	
	__proto__: StylesheetManager,
	get stylesheet(){
			try{
				let tcustomshadow = Services.prefs.getCharPref(PrefsObserver.branch + "dropdowntccshadow");
				
				if(prefs.getIntPref("dropdowntc")==5){
					return "data:text/css;charset=utf-8," + encodeURIComponent('\
						@media all and (-moz-windows-compositor){\
							menu, menuitem, .splitmenu-menuitem,\
							.menu-accel, .menu-iconic-accel {\
								text-shadow: '+tcustomshadow+' 1px 1px 1.5px !important;}\
							\
							menu[disabled="true"],menuitem[disabled="true"],\
							.splitmenu-menuitem[disabled="true"],\
							menu[_moz-menuactive="true"][disabled="true"],\
							menuitem[_moz-menuactive="true"][disabled="true"],\
							.splitmenu-menuitem[_moz-menuactive="true"][disabled="true"] {\
								text-shadow: '+tcustomshadow+' 1px 1px 1.5px !important;\
								opacity: .65 !important;}\
						}\
					');
				}
				else return "data:text/css;charset=utf-8," + encodeURIComponent('');
			}catch(e) {Cu.reportError(e)}
		}
};

var ToolbarTc = {

	__proto__: StylesheetManager,
	get stylesheet(){
		let menuvalue = Services.prefs.getIntPref(PrefsObserver.branch + "toolbartc");

		if (menuvalue==6){
		
			gmfsettings["toolbartcc"].init();
			gmfsettings["toolbartccshadow"].init();
			return "data:text/css;charset=utf-8," + encodeURIComponent('');
		}		
		
		else{
			gmfsettings["toolbartcc"].shutdown();
			gmfsettings["toolbartccshadow"].shutdown();
			
			if (menuvalue==1) { return "chrome://glassmyfox-extension/content/css/tbtc1.css"; }
			if (menuvalue==2) { return "chrome://glassmyfox-extension/content/css/tbtc2.css"; }
			if (menuvalue==3) { return "chrome://glassmyfox-extension/content/css/tbtc3.css"; }
			if (menuvalue==4) { return "chrome://glassmyfox-extension/content/css/tbtc4.css"; }
			if (menuvalue==5) { return "chrome://glassmyfox-extension/content/css/tbtc5.css"; }
		}
	}
};

var ToolbarTCColor = {
	
	__proto__: StylesheetManager,
	get stylesheet(){
			try{
				let tcustomcolor = Services.prefs.getCharPref(PrefsObserver.branch + "toolbartcc");
				
				if(prefs.getIntPref("toolbartc")==6){
					return "data:text/css;charset=utf-8," + encodeURIComponent('\
						@media all and (-moz-windows-compositor){\
							#main-window:not(:-moz-lwtheme) menubar > menu,\
							#main-window:not(:-moz-lwtheme) toolbar:not(#developer-toolbar):not(#inspector-toolbar):not(.devtools-toolbar),\
							#main-window:not(:-moz-lwtheme) toolbarbutton:not(.devtools-toolbarbutton):not(.developer-toolbar-button),\
							#browser-bottombox:not(:-moz-lwtheme),\
							#browser-bottombox:not(:-moz-lwtheme) description,\
							#main-window sidebarheader,\
							#history-panel,#bookmarksPanel,\
							#history-panel toolbarbutton,\
							#bookmarksPanel toolbarbutton{\
								color: '+tcustomcolor+' !important;}\
							#main-window:not(:-moz-lwtheme) toolbar[disabled]:not(#inspector-toolbar):not(.devtools-toolbar) toolbarbutton:not(.devtools-toolbarbutton):not(.developer-toolbar-button){\
								color: '+tcustomcolor+' !important;\
								opacity: .6 !important;\
							}\
						}\
					');
				}
				else return "data:text/css;charset=utf-8," + encodeURIComponent('');
			}catch(e) {Cu.reportError(e)}
		}
};

var ToolbarTCShadow = {
	
	__proto__: StylesheetManager,
	get stylesheet(){
			try{
				let tcustomshadow = Services.prefs.getCharPref(PrefsObserver.branch + "toolbartccshadow");
				
				if(prefs.getIntPref("toolbartc")==6){
					return "data:text/css;charset=utf-8," + encodeURIComponent('\
						@media all and (-moz-windows-compositor){\
							#main-window:not(:-moz-lwtheme) menubar > menu,\
							#main-window:not(:-moz-lwtheme) toolbar:not(#developer-toolbar):not(#inspector-toolbar):not(.devtools-toolbar),\
							#main-window:not(:-moz-lwtheme) toolbarbutton:not(.devtools-toolbarbutton):not(.developer-toolbar-button),\
							#browser-bottombox:not(:-moz-lwtheme),\
							#browser-bottombox:not(:-moz-lwtheme) description,\
							#main-window sidebarheader,\
							#history-panel,#bookmarksPanel,\
							#history-panel toolbarbutton,\
							#bookmarksPanel toolbarbutton{\
								text-shadow: '+tcustomshadow+' 1px 1px 1.5px !important;}\
							#main-window:not(:-moz-lwtheme) toolbar[disabled]:not(#inspector-toolbar):not(.devtools-toolbar) toolbarbutton:not(.devtools-toolbarbutton):not(.developer-toolbar-button){\
								text-shadow: '+tcustomshadow+' 1px 1px 1.5px !important;\
								opacity: .6 !important;\
							}\
						}\
					');
				}
				else return "data:text/css;charset=utf-8," + encodeURIComponent('');
			}catch(e) {Cu.reportError(e)}
		}
};

var SidebarTc = {

	__proto__: StylesheetManager,
	get stylesheet(){
		let menuvalue = Services.prefs.getIntPref(PrefsObserver.branch + "sidebartc");

		if (menuvalue==1){
		
			gmfsettings["sidebartcc"].init();
			return "data:text/css;charset=utf-8," + encodeURIComponent('');
		}		
		
		else{
			gmfsettings["sidebartcc"].shutdown();
			return "data:text/css;charset=utf-8," + encodeURIComponent('');
		}
	}
};

var SidebarTCColor = {
	
	__proto__: StylesheetManager,
	get stylesheet(){
			try{
				let scustomcolor = Services.prefs.getCharPref(PrefsObserver.branch + "sidebartcc");
				
				if(prefs.getIntPref("sidebartc")==1){
					return "data:text/css;charset=utf-8," + encodeURIComponent('\
						@media all and (-moz-windows-compositor){\
							#bookmarksPanel tree,\
							#history-panel tree{\
								color: '+scustomcolor+' !important;}\
						}\
					');
				}
				else return "data:text/css;charset=utf-8," + encodeURIComponent('');
			}catch(e) {Cu.reportError(e)}
		}
};

var TextboxTc = {

	__proto__: StylesheetManager,
	get stylesheet(){
		let menuvalue = Services.prefs.getIntPref(PrefsObserver.branch + "textboxtc");

		if (menuvalue==5){
		
			gmfsettings["textboxtcc"].init();
			gmfsettings["textboxtccshadow"].init();
			return "data:text/css;charset=utf-8," + encodeURIComponent('');
		}			
		
		else{
			gmfsettings["textboxtcc"].shutdown();
			gmfsettings["textboxtccshadow"].shutdown();
			
			if (menuvalue==1) return "chrome://glassmyfox-extension/content/css/textboxtc1.css";
			if (menuvalue==2) return "chrome://glassmyfox-extension/content/css/textboxtc2.css";
			if (menuvalue==3) return "chrome://glassmyfox-extension/content/css/textboxtc3.css";
			if (menuvalue==4) return "chrome://glassmyfox-extension/content/css/textboxtc4.css";
		}
	}
};

var TextboxTCColor = {
	
	__proto__: StylesheetManager,
	get stylesheet(){
			try{
				let tcustomcolor = Services.prefs.getCharPref(PrefsObserver.branch + "textboxtcc");
				
				if(prefs.getIntPref("textboxtc")==5){
					return "data:text/css;charset=utf-8," + encodeURIComponent('\
						@media all and (-moz-windows-compositor){\
							#urlbar,#urlbar box, .searchbar-textbox,dialog textbox,dialog *{\
								color: '+tcustomcolor+' !important;\
							}\
						}\
					');
				}
				else return "data:text/css;charset=utf-8," + encodeURIComponent('');
			}catch(e) {Cu.reportError(e)}
		}
};

var TextboxTCShadow = {
	
	__proto__: StylesheetManager,
	get stylesheet(){
			try{
				let tcustomshadow = Services.prefs.getCharPref(PrefsObserver.branch + "textboxtccshadow");
				
				if(prefs.getIntPref("textboxtc")==5){
					return "data:text/css;charset=utf-8," + encodeURIComponent('\
						@media all and (-moz-windows-compositor){\
							#urlbar,#urlbar box, .searchbar-textbox,dialog textbox,dialog *{\
								text-shadow:1px 1px 1.5px '+tcustomshadow+',0px 0px 2px '+tcustomshadow+',\
											1px 1px 1.5px '+tcustomshadow+',0px 0px 2px '+tcustomshadow+' !important;\
							}\
						}\
					');
				}
				else return "data:text/css;charset=utf-8," + encodeURIComponent('');
			}catch(e) {Cu.reportError(e)}
		}
};

var TabsWhiteText = {

	__proto__: StylesheetManager,
	stylesheet: "chrome://glassmyfox-extension/content/css/tabswt.css"
};

var PrefsWhiteText = {

	__proto__: StylesheetManager,
	stylesheet: "chrome://glassmyfox-extension/content/css/preferences_whitetext.css"
};

var ButtonGlass = {

	__proto__: StylesheetManager,
	stylesheet: "chrome://glassmyfox-extension/content/css/button_glass.css"
};

var NavbarButtonGlass = {

	__proto__: StylesheetManager,
	stylesheet: "chrome://glassmyfox-extension/content/css/navbarbutton_glass.css"
};

var ToolTipGlass = {

	__proto__: StylesheetManager,
	stylesheet: "chrome://glassmyfox-extension/content/css/tooltipglass.css"
};

var UrlSearchBarGlass = {

	__proto__: StylesheetManager,
	get stylesheet() {
		let menuvalue = Services.prefs.getIntPref(PrefsObserver.branch + "urlsearchbarglass");
		if (menuvalue==1) return "chrome://glassmyfox-extension/content/css/urlsearchbarglass1.css";
		if (menuvalue==2) return "chrome://glassmyfox-extension/content/css/urlsearchbarglass2.css";
		if (menuvalue==3) return "chrome://glassmyfox-extension/content/css/urlsearchbarglass3.css";
	}
};

var ToolbarTopBackgroundST = {

	__proto__: StylesheetManager,
	stylesheet: "chrome://glassmyfox-extension/content/css/toolbartopbgst.css"
};

var ToolbarBottomBackgroundST = {

	__proto__: StylesheetManager,
	stylesheet: "chrome://glassmyfox-extension/content/css/toolbarbottombgst.css"
};

var HighTabs = {

	__proto__: StylesheetManager,
	stylesheet: "chrome://glassmyfox-extension/content/css/hightabs.css"
};

var TabClose = {

	__proto__: StylesheetManager,
	stylesheet: "chrome://glassmyfox-extension/content/css/tabclose.css"
};

var WhiteTbB = {

	__proto__: StylesheetManager,
	stylesheet: "chrome://glassmyfox-extension/content/css/whitetbbut.css"
};

var HighBmBar = {

	__proto__: StylesheetManager,
	stylesheet: "chrome://glassmyfox-extension/content/css/highbookm.css"
};

var MenuSeperator = {

	__proto__: StylesheetManager,
	stylesheet: "chrome://glassmyfox-extension/content/css/mseperator.css"
};

var MenubarMoreSpace = {

	__proto__: StylesheetManager,
	stylesheet: "chrome://glassmyfox-extension/content/css/menubarmorespace.css"
};

var NoAppcontentGradient = {

	__proto__: StylesheetManager,
	stylesheet: "chrome://glassmyfox-extension/content/css/noappcontentgradient.css"
};

var FF13NewTabGlass = {

	__proto__: StylesheetManager,
	stylesheet: "chrome://glassmyfox-extension/content/css/ff13newtabglass.css"
};

var Abouttabglass = {

	__proto__: StylesheetManager,
	stylesheet: "chrome://glassmyfox-extension/content/css/abouttabglass.css"
};

var ContentGlass = {

	__proto__: StylesheetManager,
	stylesheet: "chrome://glassmyfox-extension/content/css/contentglass.css"
};

var ExpertFindbar25 = {

	__proto__: StylesheetManager,
	stylesheet: "chrome://glassmyfox-extension/content/css/expert_findbar25.css"
};

var gmfsettings = {

	"overlay": GMFOverlay,
	"mainwindowglass": MainWindowGlassSetting,
	"gmftabset": GmfTabSettings,
	"libraryglass": LibraryGlass,
	"preferencesglass": PreferenceGlass,
	"sidebarglass": SidebarGlass,
	"dlwindowglass": Downloadwindowglass,
	"appbutton": ApplicationButton,
	"appbuttonicon": ApplicationButtonIcon,
	"dropdownbg": DropDownBg,
	"dropdowntc": DropDownTc,
	"dropdowntcc": DropDownTCColor,
	"dropdowntccshadow": DropDownTCShadow,
	"toolbartc": ToolbarTc,
	"toolbartcc": ToolbarTCColor,
	"toolbartccshadow": ToolbarTCShadow,
	"sidebartc": SidebarTc,
	"sidebartcc": SidebarTCColor,
	"textboxtc": TextboxTc,
	"textboxtcc": TextboxTCColor,
	"textboxtccshadow": TextboxTCShadow,
	"tabswt": TabsWhiteText,
	"prefswt": PrefsWhiteText,
	"buttonglass": ButtonGlass,
	"navbarbuttonglass": NavbarButtonGlass,
	"tooltipglass":ToolTipGlass,
	"urlsearchbarglass":UrlSearchBarGlass,
	"toolbartopbgst": ToolbarTopBackgroundST,
	"toolbarbottombgst": ToolbarBottomBackgroundST,
	"hightabs": HighTabs,
	"tabclose": TabClose,
	"whitetbbut": WhiteTbB,
	"highbookm": HighBmBar,
	"mseperator": MenuSeperator,
	"menubarmorespace": MenubarMoreSpace,
	"noappcontentgradient": NoAppcontentGradient,
	"ff13newtabglass": FF13NewTabGlass,
	"abouttabglass": Abouttabglass,
	"contentglass": ContentGlass,
	"expfindbar25": ExpertFindbar25
};